<?php 
/*
--------------------------------------------------------------------------------

	PHP SCRIPT
	---
	For:     Amyst Design Company
	By:      Doug Linsmeyer, Amyst Design Company
	Date:    2009-09-24
	Revised:
	Version: 0

	UPDATED AND IMPROVED
	---
	For:     IMASDEWEB
	By:      Sergi Rodriguez
	Date:    2010-04-24

--------------------------------------------------------------------------------
Purpose:
Recusively search all files and sub-folders for a regex pattern and
replace it with another strong and resave the file.

Some original code by mallsop.com on 05/2001.
Updated by mallsop.com on 04/2009.
Updated by imasdeweb.com on 04/2010 
(improved the regex expression and the "calculation" of the extension of a file,
and added a backup of the hacked file before cleant it!).
PHP 5 or better. Tested ok on unix hosting box.
GPL License.
Some snippets from other php code posted online.
--------------------------------------------------------------------------------
*/

function scanDirectory($needle, $replacement, $dirid, $dirname, $path, $spaces)
{
	$a_ext=array('php','html','htm');
	while ( ($file = readdir($dirid)) != false )
	{
		if ( ($file != '.') && ($file != '..') )
		{
			$dirname_full  = $dirname.'/'.$file;
			if ( is_dir($dirname_full) && ($file != 'cgi-bin') )
			{
				$return .= $spaces . '<b>' . $file . '</b><br />' . "\n";
				$dirid_next = opendir($dirname_full); // was just $file
				$newpath = $path.'/'.$file;
				$nextspaces = $spaces.'&nbsp;&nbsp;&nbsp;&nbsp;';
				$return .= scanDirectory($needle, $replacement, $dirid_next, $dirname_full, $newpath, $nextspaces);
				$nextspaces = '';
				closedir($dirid_next);
				$dirname_here = '';
			}
			else
			{
				$break = explode('.', $file);
				$file_ext = $break[(count($break)-1)];
				$file_ext_lowercase = strtolower($file_ext);
				if ( (in_array($file_ext_lowercase,$a_ext)))
				{

					$code = file_get_contents($dirname . '/' . $file);
					if ( preg_match($needle, $code) )
					{
						$matchtext = '<span style="color:#cc0000;">...Found.</span>';
						$newcode = preg_replace($needle, $replacement, $code);
						copy($dirname . '/' . $file,$dirname . '/' . $file.'_hackedcopy');
						file_put_contents($dirname . '/' . $file, $newcode);
						$matchtext .= '...Backuped and fixed.';
					}
					else
					{
						$matchtext = '<span style="color:#00cc00;">...Not Found</span>';
					}
					$return .= $spaces . $file . $matchtext . '<br />' . "\n";

				}
			}
		}
	}
	return ($return);
}

// ====== IMPLEMENTATION ===== //

// $needle = "/eval\(base64_decode\(\"[A-Za-z0-9\=\/\+]+\"\)\);/";
// $needle = '/eval\(base64_decode\(\'[A-Za-z0-9\=\/\+]+\'\)\);/';

//Thanks to Fco for this 3rd version of the regular expresion:
// - detect single or double quotes
// - detect possible blank spaces 
$needle = '/[\s]+eval\(base64_decode\(["\'][A-Za-z0-9\=\/\+]+["\']\)\);/';

$replacement = '';
	// find the path to this directory, within the server filesystem
	$ex = explode('/',$_SERVER['SCRIPT_FILENAME']);
	$this_dirname=''; foreach($ex as $i=>$d){if ($i!=count($ex)-1 and $d!='') $this_dirname.='/'.$d;}		
$dirname_start = $this_dirname.'/';
$dirid_start = opendir($dirname_start);
$dirname_here = basename($dirname_start);
$spaces = '&nbsp;&nbsp;&nbsp;&nbsp;';
$output = scanDirectory($needle, $replacement, $dirid_start, $dirname_start, $dirname_here, $spaces);
?>
<html>
	<head>
		<title>Recursive File Search and Replace Utility by Amyst Design + IMASDEWEB, 2009-2010</title>
	</head>
	<body>
		<h1>Recursive Search and Replace Utility.</h1>
		<h2>By Amyst Design Co.</h2>
		<h3>Searching all files in the <?=$dirname_start?> folder.</h3>
		<?=$output?>
		<h3>Finished.</h3>
	</body>
</html>
